#!/bin/bash

depth=$1
patt=$2
path=$3

usage="$0 depth pattern depotpath"
nonum="Non-numeric depth: $depth"
param="Unexpected parameters provided - need three."

if [ "$#" -eq 0 ]; then echo $usage; exit 0; fi

re='^[0-9]+$'
if ! [[ $depth =~ $re ]] ; then 
	echo $usage
	echo $nonum
	exit 1
fi

if [ "$#" -ne 3 ]; then
	echo $usage
	echo $param
	exit 2
else
	echo "Searching the last $depth changes in $path for descriptions containing $patt"
fi
total=0
found=0

chgs=`p4 -F %change% -ztag changes -m$depth`
chglist=$(eval $chgs)

for c in $chglist; do
	testdesc=`p4 -F %Description% -ztag change -o $c | grep $patt`
	desc=$(eval $testdesc)
	rc=$?; if [[ $rc == 0 ]]; then echo "Change: $c"; echo "Description: $desc"; (( found++ )); fi 
	(( total++ ))
done
echo Searched $total, found $found
